package eclserver;



import java.io.DataInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.net.HttpURLConnection;
import java.net.MalformedURLException;
import java.net.URL;
import java.util.Random;


public class MainFrameO extends javax.swing.JFrame {

    /**
     * Randomly generated.
     */
	private static final long serialVersionUID = -1833425591727608149L;
	private static final Random _r = new Random(System.currentTimeMillis());
	
	/**
	 * Static values to generate contacts from.
	 */
	private final String[] mNames = new String[] {"Bradley Wyro", "Joseph Venditti", "Paul Turner", "Ricardo Totte", "Mark Tiegs", "Matthew Taylor", "Calvin Tan", "Greg Stark", "Blake Smith", "Milosz Sikora", "Lou Sicoli", "Jake Romphf", "Eric Reyes", "Chadwick Price", "Andrew Paterson", "Morgan Parker", "Paul Morley", "John McMullen", "Jeff McDowell", "Michael Mason", "Dustin Malik", "Marcelo Ludovice", "James Lambier", "Gordon Koslowski", "Sergei Klimov", "Kyle Kivimaki", "Alex Kinsella", "Justin Jones", "Marc Gervais", "Hitoshi Hishikura", "Greg Hislop", "Elliot Fung", "Luiz Fischer", "Ahmed Farrakha", "Bill Farmer", "Ian Dundas", "Fernanda Contrucci Terra", "Rodrigo Chies", "Mike Chepesky", "Trevor Cameron", "Marco Cacciacarro", "Stephen Burke", "Carsten Bergmann", "Kevin Beatty", "Westlee Barichak ", "Hisham Athas", "Enrico Antonucci"};
    private final String[] fNames = new String[] {"Meredith Wagler", "Catharina Van Denhoff", "Angela Van Daele", "Karla Tetzel", "Sarah Symonds", "Leesa Steiner", "Carol Silva", "Sheena Raj", "Ninaa Persad", "Lisa Perry", "Julie Palmer", "Tamara Moona", "Tanya McPherson", "Tina McAuley", "Annie Mathew", "Marcia Maria Marques", "Denise Marshall", "Christina Lucey", "Jayne Lord", "Nicole Lavigne", "Christine Kwan", "Trudy Koen", "Christa Johnston", "Mika Ilvonen", "Rachel Grimard", "Sylwia Glowik", "Rose George", "Krista Hunter", "Caitlin Howlett", "Alida Droogendyk", "Fernanda De Oliveira Santos", "Jeanette deBoer", "Sherisse Da Silva", "Lindsay Cournoyer", "Tetyana Chuchkevych", "Natalie Carruthers", "Megan Ball", "Andrea Aime", "Megan Acheson"};
    private final String[] cities = new String[] {"2200 University Ave. E., Waterloo, ON", "2300 University Ave. E., Waterloo, ON", "141 Weber St. S., Waterloo, ON", "619 Kumpf Dr., Waterloo, ON", "300 Hagey Blvd., Waterloo, ON", "460 Phillip St., Waterloo, ON", "195 Columbia St. W., Waterloo, ON", "440 Phillip St., Waterloo, ON", "450 Phillip St., Waterloo, ON", "419 Phillip St. W., Waterloo, ON", "415 Phillip St., Waterloo, ON", "176 Columbia St. W., Waterloo, ON", "455 Phillip St., Waterloo, ON", "451 Phillip St., Waterloo, ON", "180 Columbia St. W., Waterloo, ON", "170 Columbia St. W., Waterloo, ON", "156 Columbia St. W., Waterloo, ON", "305 Phillip St., Waterloo, ON", "185 Columbia St. W., Waterloo, ON", "295 Phillip St., Waterloo, ON", "175 Columbia St. W., Waterloo, ON"};

    /**
     * On launch.
     */
	public MainFrameO() {
		this.setTitle("BE1S Push Server");
        initComponents();
        jButton2MouseClicked(null); //Generate a random contact.
    }

	/**
	 * Reset MDS configuration to Simulator defaults.
	 * @param evt
	 */
    private void jButton1MouseClicked(java.awt.event.MouseEvent evt) {
        txtMDSAddress.setText("localhost");
        txtMDSPort.setText("28080");
        txtDevicePIN.setText("2100000A");
        txtDevicePort.setText("233");
    }

    /**
     * Generate a random contact.
     * @param evt
     */
    private void jButton2MouseClicked(java.awt.event.MouseEvent evt) {
    	//ID = Random integer.
        txtCID.setText(String.valueOf(Math.abs(_r.nextInt())));
        
        //Pick a random gender and name from the associated names list.
        String name = "";
        if(_r.nextBoolean()) {
            radCMale.setSelected(true);
            name = mNames[_r.nextInt(mNames.length)];
        } else {
            radCFemale.setSelected(true);
            name = fNames[_r.nextInt(fNames.length)];
        }
        txtCName.setText(name);
        
        //Phone number is generated by picking 2 random integers.
        String phone = "(519) 555-01";
        phone = phone + _r.nextInt(10);
        phone = phone + _r.nextInt(10);
        txtCPhone.setText(phone);
        
        //Generate a random email.
        String email = "userXYZ@rim.com";
        email = email.replace("X", String.valueOf(_r.nextInt(10)));
        email = email.replace("Y", String.valueOf(_r.nextInt(10)));
        email = email.replace("Z", String.valueOf(_r.nextInt(10)));
        txtCEmail.setText(email);
        
        //Generated device PIN is statically set to: 2100000A. This is the default Simulator PIN.
        String pin = "2100000A";
        txtCPIN.setText(pin);
        
        //Pick a random location from our list.
        txtCAddress.setText(cities[_r.nextInt(cities.length)]);
    }

    /**
     * Add the current contact to our JSON String.
     * @param evt
     */
    private void jButton3MouseClicked(java.awt.event.MouseEvent evt) {
        String text = "{\"id\":\"[0]\",\"sex\":\"[1]\",\"name\":\"[2]\",\"tele\":\"[3]\",\"email\":\"[4]\",\"pin\":\"[5]\",\"addr\":\"[6]\"}";
        text = text.replace("[0]", txtCID.getText());
        text = text.replace("[1]", radCMale.isSelected() ? "male" : "female");
        text = text.replace("[2]", txtCName.getText());
        text = text.replace("[3]", txtCPhone.getText());
        text = text.replace("[4]", txtCEmail.getText());
        text = text.replace("[5]", txtCPIN.getText());
        text = text.replace("[6]", txtCAddress.getText());
        
        String json = txtJSON.getText();
        json = json.substring(0, json.length() - 2) + text + "]}";
        json = json.replace("}{", "},{");
        txtJSON.setText(json);
    }

    /**
     * Generate a URL based on our MDS and Device configuration.
     * @return
     * @throws MalformedURLException
     */
    private URL getPushURL() throws MalformedURLException {
        String pin = txtDevicePIN.getText();
        String port = txtDevicePort.getText();
        return new URL("http", txtMDSAddress.getText(), Integer.valueOf(txtMDSPort.getText()).intValue(), "/push?DESTINATION=" + pin + "&PORT=" + port + "&REQUESTURI=/");
    }
    
    /**
     * Push the content.
     * @param evt
     */
    private void jButton4MouseClicked(java.awt.event.MouseEvent evt) {
        String data = txtJSON.getText();
        String pushId = "pushID:" + _r.nextInt();

        HttpURLConnection conn = null;
        OutputStream out = null;
        InputStream ins = null;

        try {
            URL url = getPushURL();
            System.out.println(url.toString());

            conn = (HttpURLConnection)url.openConnection();
            conn.setDoInput(true);
            conn.setDoOutput(true);
            conn.setRequestMethod("POST");
            conn.setRequestProperty("X-RIM-PUSH-ID", pushId);
            conn.setRequestProperty("X-RIM-Push-Reliability-Mode", "TRANSPORT");

            out = conn.getOutputStream();
            out.write(data.getBytes());

            int contentLength = conn.getContentLength();
            if (contentLength > 0) {
                byte[] someArray = new byte[contentLength];
                ins = conn.getInputStream();
                DataInputStream dins = new DataInputStream(ins);
                dins.readFully(someArray);
                System.out.println(new String(someArray));
            }
        } catch (IOException e) {
            System.err.println(e);
        } finally {
            if(ins != null) {
                try {
                	ins.close();
                } catch (Exception ex) {
                }
                ins = null;
            }

            if (out != null) {
                try {
                    out.close();
                } catch (Exception ex) {
                }
                out = null;
            }

            if (conn != null) {
                conn.disconnect();
                conn = null;
            }
        }
    }

    /**
     * Reset our JSON String.
     * @param evt
     */
    private void jButton5MouseClicked(java.awt.event.MouseEvent evt) {
        txtJSON.setText("{\"contact\":[]}");
    }

    /**
     * Our main entry point.
     * @param args
     */
    public static void main(String args[]) {
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                new MainFrameO().setVisible(true);
            }
        });
    }

    /**
     * GUI Object declarations.
     */
    private javax.swing.ButtonGroup buttonGroup1;
    private javax.swing.JButton jButton1;
    private javax.swing.JButton jButton2;
    private javax.swing.JButton jButton3;
    private javax.swing.JButton jButton4;
    private javax.swing.JButton jButton5;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel10;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JLabel jLabel5;
    private javax.swing.JLabel jLabel6;
    private javax.swing.JLabel jLabel7;
    private javax.swing.JLabel jLabel8;
    private javax.swing.JLabel jLabel9;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JPanel jPanel2;
    private javax.swing.JPanel jPanel3;
    private javax.swing.JPanel jPanel4;
    private javax.swing.JPanel jPanel5;
    private javax.swing.JPanel jPanel6;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JRadioButton radCFemale;
    private javax.swing.JRadioButton radCMale;
    private javax.swing.JTextField txtCAddress;
    private javax.swing.JTextField txtCEmail;
    private javax.swing.JTextField txtCID;
    private javax.swing.JTextField txtCName;
    private javax.swing.JTextField txtCPIN;
    private javax.swing.JTextField txtCPhone;
    private javax.swing.JTextField txtDevicePIN;
    private javax.swing.JTextField txtDevicePort;
    private javax.swing.JTextArea txtJSON;
    private javax.swing.JTextField txtMDSAddress;
    private javax.swing.JTextField txtMDSPort;
    
    /**
	 * Generated with NetBeans.
	 */
    private void initComponents() {

        buttonGroup1 = new javax.swing.ButtonGroup();
        jPanel1 = new javax.swing.JPanel();
        jPanel2 = new javax.swing.JPanel();
        jLabel1 = new javax.swing.JLabel();
        jLabel2 = new javax.swing.JLabel();
        txtMDSAddress = new javax.swing.JTextField();
        txtMDSPort = new javax.swing.JTextField();
        jPanel3 = new javax.swing.JPanel();
        jLabel3 = new javax.swing.JLabel();
        txtDevicePIN = new javax.swing.JTextField();
        jLabel4 = new javax.swing.JLabel();
        txtDevicePort = new javax.swing.JTextField();
        jButton1 = new javax.swing.JButton();
        jPanel4 = new javax.swing.JPanel();
        jPanel5 = new javax.swing.JPanel();
        jLabel5 = new javax.swing.JLabel();
        txtCID = new javax.swing.JTextField();
        radCMale = new javax.swing.JRadioButton();
        radCFemale = new javax.swing.JRadioButton();
        jLabel7 = new javax.swing.JLabel();
        txtCName = new javax.swing.JTextField();
        jLabel6 = new javax.swing.JLabel();
        txtCPhone = new javax.swing.JTextField();
        jLabel8 = new javax.swing.JLabel();
        txtCEmail = new javax.swing.JTextField();
        jLabel9 = new javax.swing.JLabel();
        txtCPIN = new javax.swing.JTextField();
        jLabel10 = new javax.swing.JLabel();
        txtCAddress = new javax.swing.JTextField();
        jButton3 = new javax.swing.JButton();
        jButton2 = new javax.swing.JButton();
        jPanel6 = new javax.swing.JPanel();
        jScrollPane1 = new javax.swing.JScrollPane();
        txtJSON = new javax.swing.JTextArea();
        jButton4 = new javax.swing.JButton();
        jButton5 = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);

        jPanel1.setBorder(javax.swing.BorderFactory.createTitledBorder("Configuration"));

        jPanel2.setBorder(javax.swing.BorderFactory.createTitledBorder("MDS"));

        jLabel1.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        jLabel1.setText("Address");

        jLabel2.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        jLabel2.setText("Port");

        txtMDSAddress.setText("localhost");

        txtMDSPort.setText("28080");

        javax.swing.GroupLayout jPanel2Layout = new javax.swing.GroupLayout(jPanel2);
        jPanel2.setLayout(jPanel2Layout);
        jPanel2Layout.setHorizontalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel2Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jLabel2)
                    .addComponent(jLabel1))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(txtMDSPort, javax.swing.GroupLayout.DEFAULT_SIZE, 136, Short.MAX_VALUE)
                    .addComponent(txtMDSAddress, javax.swing.GroupLayout.DEFAULT_SIZE, 136, Short.MAX_VALUE))
                .addContainerGap())
        );
        jPanel2Layout.setVerticalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel2Layout.createSequentialGroup()
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel1)
                    .addComponent(txtMDSAddress, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(txtMDSPort, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel2))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        jPanel3.setBorder(javax.swing.BorderFactory.createTitledBorder("Device"));

        jLabel3.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        jLabel3.setText("PIN");

        txtDevicePIN.setText("2100000A");

        jLabel4.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        jLabel4.setText("Port");

        txtDevicePort.setText("233");

        javax.swing.GroupLayout jPanel3Layout = new javax.swing.GroupLayout(jPanel3);
        jPanel3.setLayout(jPanel3Layout);
        jPanel3Layout.setHorizontalGroup(
            jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel3Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jLabel4)
                    .addComponent(jLabel3))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(txtDevicePIN, javax.swing.GroupLayout.DEFAULT_SIZE, 136, Short.MAX_VALUE)
                    .addComponent(txtDevicePort, javax.swing.GroupLayout.DEFAULT_SIZE, 136, Short.MAX_VALUE))
                .addContainerGap())
        );
        jPanel3Layout.setVerticalGroup(
            jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel3Layout.createSequentialGroup()
                .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel3)
                    .addComponent(txtDevicePIN, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel3Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel4)
                    .addComponent(txtDevicePort, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)))
        );

        jButton1.setText("Load Default");
        jButton1.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                jButton1MouseClicked(evt);
            }
        });

        javax.swing.GroupLayout jPanel1Layout = new javax.swing.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jButton1)
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel1Layout.createSequentialGroup()
                        .addComponent(jPanel2, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jPanel3, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)))
                .addContainerGap())
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addComponent(jButton1)
                .addGap(2, 2, 2)
                .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jPanel3, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jPanel2, javax.swing.GroupLayout.PREFERRED_SIZE, 75, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addContainerGap())
        );

        jPanel4.setBorder(javax.swing.BorderFactory.createTitledBorder("Push Content"));

        jPanel5.setBorder(javax.swing.BorderFactory.createTitledBorder("New Contact"));

        jLabel5.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        jLabel5.setText("ID");

        txtCID.setText("");

        buttonGroup1.add(radCMale);
        radCMale.setText("Male");

        buttonGroup1.add(radCFemale);
        radCFemale.setText("Female");

        jLabel7.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        jLabel7.setText("Name");

        txtCName.setText("");

        jLabel6.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        jLabel6.setText("Phone");

        txtCPhone.setText("");

        jLabel8.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        jLabel8.setText("Email");

        txtCEmail.setText("");

        jLabel9.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        jLabel9.setText("PIN");

        txtCPIN.setText("");

        jLabel10.setHorizontalAlignment(javax.swing.SwingConstants.RIGHT);
        jLabel10.setText("Address");

        txtCAddress.setText("");

        jButton3.setText("Add Contact");
        jButton3.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                jButton3MouseClicked(evt);
            }
        });

        jButton2.setText("Randomize");
        jButton2.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                jButton2MouseClicked(evt);
            }
        });

        javax.swing.GroupLayout jPanel5Layout = new javax.swing.GroupLayout(jPanel5);
        jPanel5.setLayout(jPanel5Layout);
        jPanel5Layout.setHorizontalGroup(
            jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel5Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                    .addComponent(jLabel5, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(jLabel7, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(jLabel9, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(jLabel6, javax.swing.GroupLayout.Alignment.TRAILING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel5Layout.createSequentialGroup()
                        .addGroup(jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                            .addGroup(javax.swing.GroupLayout.Alignment.LEADING, jPanel5Layout.createSequentialGroup()
                                .addGroup(jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                    .addComponent(txtCPhone, javax.swing.GroupLayout.PREFERRED_SIZE, 90, javax.swing.GroupLayout.PREFERRED_SIZE)
                                    .addComponent(txtCPIN, javax.swing.GroupLayout.PREFERRED_SIZE, 90, javax.swing.GroupLayout.PREFERRED_SIZE))
                                .addGap(18, 18, 18)
                                .addGroup(jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                                    .addComponent(jLabel8, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                                    .addComponent(jLabel10, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addGroup(jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                                    .addComponent(txtCAddress, javax.swing.GroupLayout.DEFAULT_SIZE, 196, Short.MAX_VALUE)
                                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel5Layout.createSequentialGroup()
                                        .addComponent(jButton2)
                                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                        .addComponent(jButton3))
                                    .addComponent(txtCEmail, javax.swing.GroupLayout.DEFAULT_SIZE, 196, Short.MAX_VALUE)))
                            .addGroup(javax.swing.GroupLayout.Alignment.LEADING, jPanel5Layout.createSequentialGroup()
                                .addComponent(txtCName, javax.swing.GroupLayout.PREFERRED_SIZE, 181, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(radCMale)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(radCFemale)))
                        .addContainerGap())
                    .addGroup(jPanel5Layout.createSequentialGroup()
                        .addComponent(txtCID, javax.swing.GroupLayout.DEFAULT_SIZE, 347, Short.MAX_VALUE)
                        .addContainerGap())))
        );
        jPanel5Layout.setVerticalGroup(
            jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel5Layout.createSequentialGroup()
                .addGroup(jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel5)
                    .addComponent(txtCID, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(radCFemale)
                    .addComponent(radCMale)
                    .addComponent(jLabel7)
                    .addComponent(txtCName, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel6)
                    .addComponent(txtCPhone, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(jLabel8)
                    .addComponent(txtCEmail, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel10)
                    .addComponent(jLabel9)
                    .addComponent(txtCPIN, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addComponent(txtCAddress, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel5Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jButton3)
                    .addComponent(jButton2)))
        );

        jPanel6.setBorder(javax.swing.BorderFactory.createTitledBorder("JSON String"));

        txtJSON.setColumns(20);
        txtJSON.setRows(5);
        txtJSON.setLineWrap(true);
        txtJSON.setWrapStyleWord(false);
        txtJSON.setText("{\"contact\":[]}");
        jScrollPane1.setViewportView(txtJSON);

        jButton4.setText("Send Push");
        jButton4.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                jButton4MouseClicked(evt);
            }
        });

        jButton5.setText("Reset");
        jButton5.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                jButton5MouseClicked(evt);
            }
        });

        javax.swing.GroupLayout jPanel6Layout = new javax.swing.GroupLayout(jPanel6);
        jPanel6.setLayout(jPanel6Layout);
        jPanel6Layout.setHorizontalGroup(
            jPanel6Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel6Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel6Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(jScrollPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 381, Short.MAX_VALUE)
                    .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel6Layout.createSequentialGroup()
                        .addComponent(jButton5)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(jButton4)))
                .addContainerGap())
        );
        jPanel6Layout.setVerticalGroup(
            jPanel6Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel6Layout.createSequentialGroup()
                .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel6Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jButton4)
                    .addComponent(jButton5)))
        );

        javax.swing.GroupLayout jPanel4Layout = new javax.swing.GroupLayout(jPanel4);
        jPanel4.setLayout(jPanel4Layout);
        jPanel4Layout.setHorizontalGroup(
            jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, jPanel4Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(jPanel6, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(jPanel5, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .addContainerGap())
        );
        jPanel4Layout.setVerticalGroup(
            jPanel4Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel4Layout.createSequentialGroup()
                .addComponent(jPanel5, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jPanel6, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING, false)
                    .addComponent(jPanel4, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(jPanel1, javax.swing.GroupLayout.Alignment.LEADING, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jPanel1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jPanel4, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        pack();
    }
}